/*
 * note.h
 *
 *  Created on: 20.09.2010
 *      Author: Hendrik Helwich <h.helwich@tarent.de>,
 *      		Peter Neuhaus <p.neuhaus@tarent.de>,
 *      		Andreas Grau <a.grau@tarent.de>
 */

/*
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor Boston, MA 02110-1301, USA
 */

#ifndef NOTE_H_
#define NOTE_H_


#include "common.h"

/**
 * internal data structure for notes
 */
typedef struct {
	I_common 	*common;
	GString 	*summary;	//default empty
} I_note;

/*
 * constructors
 */

I_note *new_i_note (void);

/*
 * destructors
 */

void free_i_note (I_note **);

#endif /* NOTE_H_ */
